#HP Calculator by Lorn MacIlravie, Ver 1.0.0
#Python Version 3.9.1

import datetime
import time
import sys
from tkinter import *
from tkinter.font import BOLD

window = Tk()

window.title("Horsepower")#Window Title

window.geometry('625x580')#Window Size

#Titles Etc
space0 = Label(window, text="")#Make a label and inserts a value , anchor="e", justify=LEFT
space0.grid(column=0, row=0,columnspan=20, sticky=W)#Places a label on the page.
space0.config(font =("Courier", 14, BOLD))

# Label on Page
mainLabel = Label(window, text= "  Horsepower Calculator")#Make a label and inserts a value
mainLabel.grid(column=0, row=1, columnspan=16, sticky=W)
mainLabel.config(font =("Courier", 14, BOLD)) 

space0_1 = Label(window, text="")#Make a label and inserts a value , anchor="e", justify=LEFT
space0_1.grid(column=0, row=2,columnspan=20, sticky=W)#Places a label on the page.
space0_1.config(font =("Courier", 14, BOLD))


#Functions

def clearOutputDisplays(): # Cleans up the displays
    sp_value.destroy()
    th_value.destroy()
    dc_value.destroy()


def exitButtonFunction():
    #exit()
    try:
        raise SystemExit
    except Exception:
        sys.exit()

def writeToTXTFunction():
    clearOutputDisplays()
    buttonFuction()
    
    now = datetime.datetime.now()
    year = str(now.year)
    month = str(now.month)
    day = str(now.day)
    hour = str(now.hour)
    minutes = str(now.minute)
    now = str(now)
    seconds = time.time() #Seconds since January 1st 1970
    local_time = time.ctime(seconds)
    local_time = str(local_time)
 

    myFileName = "Horse Power Calculation -- " + month + "-" + day + "-" + year + " " + hour + minutes + ".txt"
    f = open(myFileName,"a")  
    f.write("Horse Power Calculation\n\n")
    f.write("By Lorn MacIlravie, www.lornmac.com, lorn@lornmac.com, 605-603-6849\n\n")
    f.write(local_time)
    f.write("\n\n")

    singlePhaseHP = str(round(((e*i*eff*pf)/746),2))
    threePhaseHP = (e*i*eff*pf*1.732)/746
    threePhaseHP = round(threePhaseHP,2)
    directCurrentHP = (e*i*eff)/746
    directCurrentHP = round(directCurrentHP,2)

    f.write("Voltage = E = " + str(e) + "\n")
    f.write("Current = I = " + str(i) + "\n")
    f.write("Efficiency = EFF = " + str(eff) + "\n")
    f.write("Power Factor = PF = " + str(pf) + "\n\n")

    f.write("HP, Single Phase = (E x I x EFF x PF) / 746\n")
    f.write(singlePhaseHP + " = (" + str(e) + " x " + str(i) + " x " + str(eff) + " x " + str(pf) + ") / 746\n\n")

    f.write("HP, Three Phase = (E x I x EFF x PF x 1.732) / 746\n")
    f.write(str(threePhaseHP) + " = (" + str(e) + " x " + str(i) + " x " + str(eff) + " x " + str(pf) + " x 1.732) / 746\n\n")

    f.write("HP, DC = (E x I x EFF) / 746\n")
    f.write(str(directCurrentHP) + " = (" + str(e) + " x " + str(i) + " x " + str(eff) + ") / 746\n\n")

    f.write("\n")
    f.write("END of file\n\n")
    f.close()

#Main calculations are done when button, or return, is pushed
def buttonFuction():

    #These are global to make clearOutputDisplays() and writeToTXTFunction() work
    global sp_value
    global th_value
    global dc_value

    global e
    global i
    global eff
    global pf

    try:
        e = float(e_entry.get())
    except Exception: #This should catch ALL exceptions?
        e = float(0)

    try:
        i = float(i_entry.get())
    except Exception: #This should catch ALL exceptions?
        i = float(0)

    try:
        pf = float(pf_entry.get())
    except Exception: #This should catch ALL exceptions?
        pf = float(0)

    try:
        eff = float(eff_entry.get())
    except Exception: #This should catch ALL exceptions?
        eff = float(0)

    singlePhaseHP = str(round(((e*i*eff*pf)/746),2))
    threePhaseHP = (e*i*eff*pf*1.732)/746
    threePhaseHP = round(threePhaseHP,2)
    directCurrentHP = (e*i*eff)/746
    directCurrentHP = round(directCurrentHP,2)

    if e == 0 or i == 0 or eff < .01 or pf < .01:
        singlePhaseHP = "NaN"
        threePhaseHP = "NaN"
        directCurrentHP = "NaN"

    sp_value = Label(window, text= singlePhaseHP, fg='blue')#Make a label and inserts a value
    sp_value.grid(column=1, row=7)
    sp_value.config(font =("Courier", 14, BOLD)) 

    sp_label = Label(window, text= " HP, Single Phase" )#Make a label and inserts a value
    sp_label.grid(column=2, row=7, sticky=W)# sticky=W is for left justify
    sp_label.config(font =("Courier", 14)) 


    th_value = Label(window, text= threePhaseHP, fg='blue')#Make a label and inserts a value
    th_value.grid(column=1, row=8)
    th_value.config(font =("Courier", 14, BOLD)) 

    th_label = Label(window, text=" HP, Three Phase")#Make a label and inserts a value
    th_label.grid(column=2, row=8, sticky=W)
    th_label.config(font =("Courier", 14)) 


    dc_value = Label(window, text= directCurrentHP, fg='blue')#Make a label and inserts a value
    dc_value.grid(column=1, row=9)
    dc_value.config(font =("Courier", 14, BOLD)) 

    dc_label = Label(window, text=" HP, DC")#Make a label and inserts a value
    dc_label.grid(column=2, row=9, sticky=W)
    dc_label.config(font =("Courier", 14)) 


    space1 = Label(window, text="")#Make a label and inserts a value , anchor="e", justify=LEFT
    space1.grid(column=0, row=10,columnspan=20, sticky=W)#Places a label on the page.
    space1.config(font =("Courier", 14, BOLD))

    notes_label = Label(window, text="  Notes:")#Make a label and inserts a value , anchor="e", justify=LEFT
    notes_label.grid(column=0, row=11,columnspan=20, sticky=W)#Places a label on the page.
    notes_label.config(font =("Courier", 14, BOLD))

    space1_1 = Label(window, text="")#Make a label and inserts a value , anchor="e", justify=LEFT
    space1_1.grid(column=0, row=12,columnspan=20, sticky=W)#Places a label on the page.
    space1_1.config(font =("Courier", 14, BOLD))


    # spCalc_label = Label(window, text="  HP, Single Phase = (E x I x EFF x PF) / 746")#Make a label and inserts a value , anchor="e", justify=LEFT
    # spCalc_label.grid(column=0, row=13,columnspan=30, sticky=W)#Places a label on the page.
    # spCalc_label.config(font =("Courier", 14))

    # tpCalc_label = Label(window, text="  HP, Three Phase = (E x I x EFF x PF x 1.732) / 746")#Make a label and inserts a value , anchor="e", justify=LEFT
    # tpCalc_label.grid(column=0, row=14,columnspan=30, sticky=W)#Places a label on the page.
    # tpCalc_label.config(font =("Courier", 15))

    # dcCalc_label = Label(window, text="  HP, DC = (E x I x EFF) / 746")#Make a label and inserts a value , anchor="e", justify=LEFT
    # dcCalc_label.grid(column=0, row=15,columnspan=30, sticky=W)#Places a label on the page.
    # dcCalc_label.config(font =("Courier", 17))

    spCalc_label = Label(window, text="  HP, Single Phase = (E x I x EFF x PF) / 746")#Make a label and inserts a value , anchor="e", justify=LEFT
    spCalc_label.grid(column=0, row=13,columnspan=30, sticky=W)#Places a label on the page.
    spCalc_label.config(font =("Courier", 14))

    #Results Here row 14

    tpCalc_label = Label(window, text="  HP, Three Phase = (E x I x EFF x PF x 1.732) / 746")#Make a label and inserts a value , anchor="e", justify=LEFT
    tpCalc_label.grid(column=0, row=14,columnspan=30, sticky=W)#Places a label on the page.
    tpCalc_label.config(font =("Courier", 14))

    #Results Here row 16

    dcCalc_label = Label(window, text="  HP, DC = (E x I x EFF) / 746")#Make a label and inserts a value , anchor="e", justify=LEFT
    dcCalc_label.grid(column=0, row=15,columnspan=30, sticky=W)#Places a label on the page.
    dcCalc_label.config(font =("Courier", 14))

    #Results Here row 17

    
#################### END of buttonFunction  #################



#Entry and Lable Setup and Preliminary Values

zero_three = Label(window, text="   ")#Make a label and inserts a value , anchor="e", justify=LEFT
zero_three.grid(column=0, row=3, sticky=W)#Places a label on the page.
zero_three.config(font =("Courier", 14)) 


e_entry = Entry(window,width=10, justify = CENTER)#Makes and Entry Box - Makes an obj
e_entry.insert(0, 460)#Inserts value into object
e_entry.grid(column=1, row=3)
e_entry.config(font =("Courier", 14)) 

e_label = Label(window, text=" Voltage (E)")#Make a label and inserts a value , anchor="e", justify=LEFT
e_label.grid(column=2, row=3, sticky=W)#Places a label on the page.
e_label.config(font =("Courier", 14)) 


i_entry = Entry(window,width=10, justify = CENTER)
i_entry.insert(0,50)
i_entry.grid(column=1, row=4)
i_entry.config(font =("Courier", 14)) 

i_label = Label(window, text=" Current (I)")
i_label.grid(column=2, row=4, sticky=W)
i_label.config(font =("Courier", 14)) 


eff_entry = Entry(window,width=10, justify = CENTER)
eff_entry.insert(0,0.96)
eff_entry.grid(column=1, row=5)
eff_entry.config(font =("Courier", 14)) 

eff_label = Label(window, text=" Efficiency (EFF)")
eff_label.grid(column=2, row=5, sticky=W)
eff_label.config(font =("Courier", 14)) 


pf_entry =  Entry(window,width=10, justify = CENTER )
pf_entry.insert(0,0.87)
pf_entry.grid(column=1, row=6)
pf_entry.config(font =("Courier", 14)) 

pf_label = Label(window, text=" Power Factor (PF)")
pf_label.grid(column=2, row=6, sticky=W)
pf_label.config(font =("Courier", 14)) 

#Runs calculations on load
buttonFuction()



#Click and Return Function

def onclick(event=None):
    clearOutputDisplays()
    print("You clicked the button")
    buttonFuction()
   
window.bind('<Return>', onclick)


#Calc Button
calcButton = Button(text="CALCULATE", command= onclick,  bg='green', fg='black', width = 15)
calcButton.grid(column=20, row=1)
calcButton.config(font =("Courier", 14, BOLD)) 

# Change to row 18
# Space on Page
space2 = Label(window, text="")#Make a label and inserts a value , anchor="e", justify=LEFT
space2.grid(column=0, row=16,columnspan=20, sticky=W)#Places a label on the page.
space2.config(font =("Courier", 14, BOLD))

#change to row 19
# Exit Button
writeToTextButton = Button(text="WRITE TO TXT", command= writeToTXTFunction,  bg='blue', fg='white',  width = 15)
writeToTextButton.grid(column=1, row=17)
writeToTextButton.config(font =("Courier", 14)) 

#change to row 19
# Exit Button
exitButton = Button(text="Exit", command= exitButtonFunction,  bg='red', fg='white',  width = 15)
exitButton.grid(column=20, row=17)
exitButton.config(font =("Courier", 14)) 




#Leave this at the bottom    
window.mainloop()


